#!/usr/bin/perl
use MIME::Lite;
#use Data::Dumper;
use Sys::Syslog;
use IO::Socket;

# liste dossier dans les partages si necessaire
#
my $confeole = "/etc/eole/config.eol";

syslog("info", "##########################################");        #
syslog("info", "Demarrage du script gérant la mAJ de trend");        #
#on controle si l'activation du script est operationnelle
if (-e $confeole){
	@cmdlocal = `/usr/share/creole/parsedico.py`;
	foreach my $ligne (@cmdlocal) {
		#print $ligne;
		@split = split( /\=/, $ligne);
		$var = @split[0];
		$val =  @split[1];
		$val =~ s/\"//g;
		$va = chop($val);
		#on rempli le dico
		#print "$var : $val \n";
		$hash{"$var"} = $val;
	}
}
else{
syslog("info",  "Pas de fichier de configuration $confeole");
exit;
}
###variable statique

$rep_maj_trend_local = "/data/trend/";
$ln_maj_trend_local = "/var/www/trend";
$message = "";
### on controle si le rsync  est actif
$active_maj_trend = $hash{"active_maj_trend"};

if ( $active_maj_trend ne "oui" ) {
exit;
}


###### recup grace au dico
$sender = $hash{"mail_sender"};
$to_addr_maj = $hash{"to_addr_maj"};
$to_addr_maj =~ tr/ /,/;
$numero_etab = $hash{"numero_etab"};
$adresse_ip_eth0 = $hash{"adresse_ip_eth0"};
$subject_error_maj_trend =  $hash{"subject_error_maj_trend"};
$subject_error_maj_trend = $subject_error_maj_trend." ".$numero_etab." ".$adresse_ip_eth0;
$subject_ok_maj_trend =  $hash{"subject_ok_maj_trend"};
$subject_ok_maj_trend = $subject_ok_maj_trend." ".$numero_etab." ".$adresse_ip_eth0;
$active_mail_maj_trend = $hash{"active_mail_maj_trend"};
$serveur_maj_trend = $hash{"serveur_maj_trend"};
$rep_maj_source_trend = $hash{"rep_maj_source_trend"};
$random_maj_trend = $hash{"random_maj_trend"};


sub sendmail{
my (@corps) = @_;
my $Message = new MIME::Lite
	From =>@corps[0],
	To =>@corps[1],
	Subject =>@corps[2],
	Type =>'TEXT',
	Data =>@corps[3];
	$Message -> send;
return($Message);
exit;
}

sub affich_date{
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;
$year+=1900;
$mon++;
$result = "##$mday/$mon/$year, $hour:$min:$sec##\n";
return ($result);
}


sub test_rsync{
my ($adresse) = @_;
my $result = "OK";
my $socket = "";
$socket = IO::Socket::INET->new(
	Proto => "tcp",
	PeerAddr => $adresse,
	PeerPort => 873,
	Timeout => 1
	)
  or $result = "NOK";
close($socket);
return($result);
}




# controle utilisateur qui lance le script
#
if ( $< != 0 ){
   sendmail($sender,$to_addr_rsync,$subject_error_rsync_trend,"Script pas lancer en tant que root");
   die "Seulement root peut lancer ce script\n";
}


#aller on attend de façon aléatoire pour éviter d'écrouler la bande passante

if ($random_maj_trend != "00"){
my $timemax = ($random_maj_trend*60);
my $tempo = int(rand($timemax));
print $tempo,"\n";
sleep $tempo;
}







#### on commence par vérifier si le dossier trend de maj  existe

if ( -d "$rep_maj_trend_local"){
$message = &affich_date."Dossier $rep_maj_trend_local existant\n";
syslog("info",  "Dossier $rep_maj_trend_local existant");
}
else{
$message = &affich_date.$message."Création du dossier $rep_maj_trend_local\n";
syslog("info",  "Création du dossier $rep_maj_trend_local");
@create_dir = ("/bin/mkdir -p $rep_maj_trend_local &> /dev/null");
system(@create_dir) == 0 or sendmail($sender,$to_addr_maj,$subject_error_maj_trend,&affich_date."Erreur lors de la creation de $rep_maj_trend_local")&exit;
}


#### on créé le lien symbolique

if ( -e "$ln_maj_trend_local"){
$message = &affich_date."Dossier $ln_maj_trend_local existant\n";
syslog("info",  "lien symbolique existant $ln_maj_trend_local existant");
}
else{
$message = &affich_date.$message."Création du lien symbolique $ln_maj_trend_local\n";
syslog("info",  "Création du lien symbolique $ln_maj_trend_local");
@create_ln = ("ln -s $rep_maj_trend_local $ln_maj_trend_local &> /dev/null");
system(@create_ln) == 0 or sendmail($sender,$to_addr_maj,$subject_error_maj_trend,&affich_date."Erreur lors de la creation du lien symbolique $ln_maj_trend_local")&exit;
}

## on test le rsync sur le serveur

$test_maj = test_rsync($serveur_maj_trend);

if ($test_maj eq "OK"){
$message = $message."Le serveur de maj $serveur_maj_trend repond\n";
syslog("info",  "Le serveur rsync $serveur_maj_trend repond");
# rsync
$message = $message.&affich_date."MAJ des fichiers trend\n";
syslog("info",  "MAJ des fichiers trend");
@rsync_data = ("/usr/bin/rsync --recursive --links --perms --times --delete --partial $serveur_maj_trend\:\:$rep_maj_source_trend $rep_maj_trend_local");
#print "/usr/bin/rsync --recursive --links --perms --times --delete --partial $serveur_rsync_trend\:\:$rep_rsync_source_trend $rep_rsync_trend_local";
system(@rsync_data) == 0 or sendmail($sender,$to_addr_maj,$subject_error_maj_trend,&affich_date."Erreur lors du rsync des MAJ")&exit;
}
else{
sendmail($sender,$to_addr_maj,$subject_error_maj_trend,&affich_date."Le serveur rsync de maj à l'adresse  $serveur_maj_trend ne repond pas")&exit;
}

$message = $message.&affich_date."Fin du rsync des maj\n";
syslog("info",  "Fin du rsync des MAJ");

##### on va afficher le md5sum de chaque fichier

$message = $message."contrôle du contenu du dossier $rep_maj_trend_local\n\n\n";


$dirname = $rep_maj_trend_local;
`cd $rep_maj_trend_local`;
opendir ( DIR, $dirname ) || die "Error in opening dir $dirname\n";
while( ($filename = readdir(DIR))){
	if ( -f "$rep_maj_trend_local/$filename"){
	$message  =  $message."md5sum du fichier ".`md5sum $rep_maj_trend_local/$filename`;
	}
}
closedir(DIR);



##########################


### envoi du mail ou syslog

if ( $active_mail_maj_trend eq "oui" ){
sendmail($sender,$to_addr_maj,$subject_ok_maj_trend,"$message");
}
else{
syslog("info",  "MAJ terminé avec succes");
}
exit;



exit;





